<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::NcpBase Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d9/dc8/classThread_1_1NcpBase.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="../../d5/da5/classThread_1_1NcpBase-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::NcpBase Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for Thread::NcpBase:</div>
<div class="dyncontent">
<div class="center"><img src="../../de/d76/classThread_1_1NcpBase__inherit__graph.png" border="0" usemap="#Thread_1_1NcpBase_inherit__map" alt="Inheritance graph"/></div>
<map name="Thread_1_1NcpBase_inherit__map" id="Thread_1_1NcpBase_inherit__map">
<area shape="rect" id="node2" href="../../d0/d2a/classThread_1_1NcpSpi.html" title="Thread::NcpSpi" alt="" coords="5,79,119,104"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html" title="Thread::NcpUart" alt="" coords="144,79,264,104"/>
</map>
<center><span class="legend">[<a target="top" href="../../graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for Thread::NcpBase:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d6f/classThread_1_1NcpBase__coll__graph.png" border="0" usemap="#Thread_1_1NcpBase_coll__map" alt="Collaboration graph"/></div>
<map name="Thread_1_1NcpBase_coll__map" id="Thread_1_1NcpBase_coll__map">
<area shape="rect" id="node2" href="../../d2/d83/structotInstance.html" title="This type represents all the static / global variables used by OpenThread allocated in one place..." alt="" coords="1179,156,1262,181"/>
<area shape="rect" id="node3" href="../../d6/d3f/structotEnergyScanResult.html" title="This struct represents an energy scan result. " alt="" coords="834,32,977,57"/>
<area shape="rect" id="node4" href="../../d2/dfb/classThread_1_1Ip6_1_1NetifCallback.html" title="This class implements network interface handlers. " alt="" coords="817,81,993,107"/>
<area shape="rect" id="node5" href="../../d3/d8e/classThread_1_1ThreadNetif.html" title="Thread::ThreadNetif" alt="" coords="835,183,975,208"/>
<area shape="rect" id="node6" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html" title="This class implements an IPv6 network interface. " alt="" coords="539,183,663,208"/>
<area shape="rect" id="node7" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html" title="This class implements the core IPv6 message processing. " alt="" coords="342,153,458,179"/>
<area shape="rect" id="node8" href="../../d8/de8/classThread_1_1TaskletScheduler.html" title="This class implements the tasklet scheduler. " alt="" coords="5,5,178,31"/>
<area shape="rect" id="node9" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html" title="This class implements ICMPv6. " alt="" coords="29,55,155,80"/>
<area shape="rect" id="node10" href="../../dd/d60/classThread_1_1Ip6_1_1Mpl.html" title="This class implements MPL message processing. " alt="" coords="32,104,151,129"/>
<area shape="rect" id="node11" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html" title="This class implements core UDP message handling. " alt="" coords="31,153,152,179"/>
<area shape="rect" id="node12" href="../../d5/d9f/classThread_1_1MessagePool.html" title="Thread::MessagePool" alt="" coords="16,203,167,228"/>
<area shape="rect" id="node13" href="../../db/ddb/classThread_1_1Ip6_1_1Routes.html" title="This class implements IPv6 route management. " alt="" coords="22,252,161,277"/>
<area shape="rect" id="node14" href="../../df/d1f/classThread_1_1TimerScheduler.html" title="This class implements the timer scheduler. " alt="" coords="9,301,174,327"/>
<area shape="rect" id="node15" href="../../d1/de8/structotActiveScanResult.html" title="This struct represents a received IEEE 802.15.4 Beacon. " alt="" coords="837,269,974,295"/>
<area shape="rect" id="node16" href="../../d3/d8f/structotExtAddress.html" title="This type represents the IEEE 802.15.4 Extended Address. " alt="" coords="551,232,652,257"/>
<area shape="rect" id="node17" href="../../d2/d0a/structotSteeringData.html" title="This structure represents the steering data. " alt="" coords="546,281,656,307"/>
<area shape="rect" id="node18" href="../../dc/d20/structotExtendedPanId.html" title="This structure represents an Extended PAN ID. " alt="" coords="539,331,663,356"/>
<area shape="rect" id="node19" href="../../df/d91/structotNetworkName.html" title="This structure represents a Network Name. " alt="" coords="543,380,660,405"/>
<area shape="rect" id="node20" href="../../d2/de5/classThread_1_1Crypto_1_1MbedTls.html" title="This class implements mbedTLS memory. " alt="" coords="821,319,990,344"/>
</map>
<center><span class="legend">[<a target="top" href="../../graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6a04825243722f9500cac2818a07c7b4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#a6a04825243722f9500cac2818a07c7b4">NcpBase</a> (<a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *aInstance)</td></tr>
<tr class="memdesc:a6a04825243722f9500cac2818a07c7b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">This constructor creates and initializes an <a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html">NcpBase</a> instance.  <a href="#a6a04825243722f9500cac2818a07c7b4">More...</a><br /></td></tr>
<tr class="separator:a6a04825243722f9500cac2818a07c7b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac89f974ddb6fd4c08343567fd74a05fe"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac89f974ddb6fd4c08343567fd74a05fe"></a>
<a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><b>SendPropertyUpdate</b> (uint8_t header, uint8_t command, spinel_prop_key_t key, const uint8_t *value_ptr, uint16_t value_len)</td></tr>
<tr class="separator:ac89f974ddb6fd4c08343567fd74a05fe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad32902d02e010c5dbaf872ae433eb1bb"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad32902d02e010c5dbaf872ae433eb1bb"></a>
<a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><b>SendPropertyUpdate</b> (uint8_t header, uint8_t command, spinel_prop_key_t key, <a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;message)</td></tr>
<tr class="separator:ad32902d02e010c5dbaf872ae433eb1bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ecf227279668404ded52e44fc6ee9ee"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5ecf227279668404ded52e44fc6ee9ee"></a>
<a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><b>SendPropertyUpdate</b> (uint8_t header, uint8_t command, spinel_prop_key_t key, const char *format,...)</td></tr>
<tr class="separator:a5ecf227279668404ded52e44fc6ee9ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:aa42f5d6c360b6b1203d3f808d59c47f3"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#aa42f5d6c360b6b1203d3f808d59c47f3">OutboundFrameBegin</a> (void)=0</td></tr>
<tr class="memdesc:aa42f5d6c360b6b1203d3f808d59c47f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method is called to start a new outbound frame.  <a href="#aa42f5d6c360b6b1203d3f808d59c47f3">More...</a><br /></td></tr>
<tr class="separator:aa42f5d6c360b6b1203d3f808d59c47f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9f0899a44608aaa83751fb657592317"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#ad9f0899a44608aaa83751fb657592317">OutboundFrameFeedData</a> (const uint8_t *aDataBuffer, uint16_t aDataBufferLength)=0</td></tr>
<tr class="memdesc:ad9f0899a44608aaa83751fb657592317"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method adds data to the current outbound frame being written.  <a href="#ad9f0899a44608aaa83751fb657592317">More...</a><br /></td></tr>
<tr class="separator:ad9f0899a44608aaa83751fb657592317"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad1df691c323b4b58912f402465450375"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#ad1df691c323b4b58912f402465450375">OutboundFrameFeedMessage</a> (<a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage)=0</td></tr>
<tr class="memdesc:ad1df691c323b4b58912f402465450375"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method adds a message to the current outbound frame being written.  <a href="#ad1df691c323b4b58912f402465450375">More...</a><br /></td></tr>
<tr class="separator:ad1df691c323b4b58912f402465450375"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0ddbeb24870f94ca94028e6707e8ffb"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#aa0ddbeb24870f94ca94028e6707e8ffb">OutboundFrameEnd</a> (void)=0</td></tr>
<tr class="memdesc:aa0ddbeb24870f94ca94028e6707e8ffb"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method finalizes and sends the current outbound frame.  <a href="#aa0ddbeb24870f94ca94028e6707e8ffb">More...</a><br /></td></tr>
<tr class="separator:aa0ddbeb24870f94ca94028e6707e8ffb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad14f0f1d60c77f7f537a0a441a9fb35c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad14f0f1d60c77f7f537a0a441a9fb35c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c">IncrementFrameErrorCounter</a> (void)</td></tr>
<tr class="memdesc:ad14f0f1d60c77f7f537a0a441a9fb35c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method is called by the framer whenever a framing error is detected. <br /></td></tr>
<tr class="separator:ad14f0f1d60c77f7f537a0a441a9fb35c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3a325e6ac211c2a40186dd78d1e88e42"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3a325e6ac211c2a40186dd78d1e88e42"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#a3a325e6ac211c2a40186dd78d1e88e42">HandleReceive</a> (const uint8_t *buf, uint16_t bufLength)</td></tr>
<tr class="memdesc:a3a325e6ac211c2a40186dd78d1e88e42"><td class="mdescLeft">&#160;</td><td class="mdescRight">Called by the subclass to indicate when a frame has been received. <br /></td></tr>
<tr class="separator:a3a325e6ac211c2a40186dd78d1e88e42"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22e9a31900fdf4eb3ef49dc32987f44c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a22e9a31900fdf4eb3ef49dc32987f44c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html#a22e9a31900fdf4eb3ef49dc32987f44c">HandleSpaceAvailableInTxBuffer</a> (void)</td></tr>
<tr class="memdesc:a22e9a31900fdf4eb3ef49dc32987f44c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Called by the subclass to indicate when a frame was removed and some space in tx buffer is available. <br /></td></tr>
<tr class="separator:a22e9a31900fdf4eb3ef49dc32987f44c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:aa38f7515ef47e9ba64ea7bd3f0781c08"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa38f7515ef47e9ba64ea7bd3f0781c08"></a>
<a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>mInstance</b></td></tr>
<tr class="separator:aa38f7515ef47e9ba64ea7bd3f0781c08"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a6a04825243722f9500cac2818a07c7b4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Thread::NcpBase::NcpBase </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *&#160;</td>
          <td class="paramname"><em>aInstance</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This constructor creates and initializes an <a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html">NcpBase</a> instance. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aInstance</td><td>The OpenThread instance structure. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d9/dc8/classThread_1_1NcpBase_a6a04825243722f9500cac2818a07c7b4_cgraph.png" border="0" usemap="#d9/dc8/classThread_1_1NcpBase_a6a04825243722f9500cac2818a07c7b4_cgraph" alt=""/></div>
<map name="d9/dc8/classThread_1_1NcpBase_a6a04825243722f9500cac2818a07c7b4_cgraph" id="d9/dc8/classThread_1_1NcpBase_a6a04825243722f9500cac2818a07c7b4_cgraph">
<area shape="rect" id="node2" href="../../df/d4f/group__config-general.html#gaa280497ee93a71ecfc7c0920ebd9e2d3" title="This function registers a callback to indicate when certain configuration or state changes within Ope..." alt="" coords="260,96,449,121"/>
<area shape="rect" id="node6" href="../../db/de8/group__ip6.html#gaef68a2e4dd98fdce1b9a007dbbf59786" title="This function registers a callback to provide received IPv6 datagrams. " alt="" coords="240,225,469,251"/>
<area shape="rect" id="node8" href="../../d8/dd2/group__diags.html#gaae3520103d17a0206ef7889d64d278e8" title="This function registers a callback to provide received raw IEEE 802.15.4 frames. " alt="" coords="275,312,434,337"/>
<area shape="rect" id="node11" href="../../db/de8/group__ip6.html#ga0ce509edb0c426cf48cb5bac1f7542cc" title="This function sets whether or not ICMPv6 Echo processing is enabled. " alt="" coords="274,375,435,400"/>
<area shape="rect" id="node13" href="../../d4/d92/classThread_1_1Tasklet.html#a50a39a6f422851035b89aace87482425" title="This method puts the tasklet on the run queue. " alt="" coords="1491,701,1638,727"/>
<area shape="rect" id="node18" href="../../dc/d3c/classThread_1_1Message.html#a1ca6e4ae9889bec648ea6165a450c768" title="This method indicates whether or not link security is enabled for the message. " alt="" coords="247,476,462,515"/>
<area shape="rect" id="node19" href="../../d9/dc8/classThread_1_1NcpBase.html#aa42f5d6c360b6b1203d3f808d59c47f3" title="This method is called to start a new outbound frame. " alt="" coords="259,539,450,577"/>
<area shape="rect" id="node20" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9" title="This method returns the number of bytes in the message. " alt="" coords="257,601,452,627"/>
<area shape="rect" id="node21" href="../../d9/dc8/classThread_1_1NcpBase.html#ad1df691c323b4b58912f402465450375" title="This method adds a message to the current outbound frame being written. " alt="" coords="259,651,450,689"/>
<area shape="rect" id="node22" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="274,713,434,739"/>
<area shape="rect" id="node23" href="../../d9/dc8/classThread_1_1NcpBase.html#ad9f0899a44608aaa83751fb657592317" title="This method adds data to the current outbound frame being written. " alt="" coords="259,763,450,801"/>
<area shape="rect" id="node24" href="../../d4/d08/misc_8h.html#ab26ce83d07357b4c94234a5c12aff289" title="This function returns the reason for the last platform reset. " alt="" coords="276,825,433,851"/>
<area shape="rect" id="node25" href="../../d8/dd2/group__diags.html#gafa791cc780f1b875634910cdec471b91" title="Get the device role. " alt="" coords="293,875,415,900"/>
<area shape="rect" id="node28" href="../../d0/d0a/group__commands.html#ga0b5e932f27ea83d933d8c0b2ec58c340" title="This function indicates whether a node is the only router on the network. " alt="" coords="305,924,404,949"/>
<area shape="rect" id="node30" href="../../d0/d0a/group__commands.html#ga9dd31b4b5ff1c0b06a39683bc5196972" title="This function stops Thread protocol operation. " alt="" coords="303,973,405,999"/>
<area shape="rect" id="node46" href="../../d9/dc8/classThread_1_1NcpBase.html#aa0ddbeb24870f94ca94028e6707e8ffb" title="This method finalizes and sends the current outbound frame. " alt="" coords="259,1023,450,1061"/>
<area shape="rect" id="node3" href="../../d2/dfb/classThread_1_1Ip6_1_1NetifCallback.html#a62c27f48c8a83f2ae89b65d6518119d5" title="This method tests whether the object is free or in use. " alt="" coords="530,5,706,44"/>
<area shape="rect" id="node4" href="../../d2/dfb/classThread_1_1Ip6_1_1NetifCallback.html#a994d81f140fa4a62245e3336d37f0aaf" title="This method sets the callback information. " alt="" coords="517,68,720,93"/>
<area shape="rect" id="node5" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html#aca4693ab30ec940aef090d8228ea4429" title="This method registers a network interface callback. " alt="" coords="553,117,683,156"/>
<area shape="rect" id="node7" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#ae0cb5116c8ca893d7067d50a84b061d5" title="This method registers a callback to provide received raw IPv6 datagrams. " alt="" coords="523,180,714,219"/>
<area shape="rect" id="node9" href="../../d3/d8e/classThread_1_1ThreadNetif.html#aec59b0e172327889e9b0f4f08b0e69f9" title="This method returns a pointer to the mac object. " alt="" coords="548,243,689,281"/>
<area shape="rect" id="node10" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#aaecd625868696452024272c785f6647d" title="This function registers a callback to provide received raw IEEE 802.15.4 frames. " alt="" coords="525,305,712,344"/>
<area shape="rect" id="node12" href="../../da/dd7/classThread_1_1Ip6_1_1Icmp.html#afc6634532527100a9a9e9e1234f49e5f" title="This method sets whether or not ICMPv6 Echo processing is enabled. " alt="" coords="552,368,685,407"/>
<area shape="rect" id="node14" href="../../d8/de8/classThread_1_1TaskletScheduler.html#a137292acddf92acdef54cc7a33ea5fac" title="This method enqueues a tasklet into the run queue. " alt="" coords="1686,695,1859,733"/>
<area shape="rect" id="node15" href="../../d1/de3/group__execution.html#ga04d5608ac68a78eb3e8fc167587c61f3" title="OpenThread calls this function when the tasklet queue transitions from empty to non&#45;empty. " alt="" coords="1924,645,2084,671"/>
<area shape="rect" id="node16" href="../../d8/de8/classThread_1_1TaskletScheduler.html#aeaf526c316bbea7d53d20fa9e3c94c40" title="This method returns the pointer to the parent Ip6 structure. " alt="" coords="1918,695,2090,733"/>
<area shape="rect" id="node17" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a624d9508f3ecfa586378a3d802cb6ff7" title="This method returns the pointer to the parent otInstance structure. " alt="" coords="1907,757,2101,783"/>
<area shape="rect" id="node26" href="../../d3/d8e/classThread_1_1ThreadNetif.html#ad49d56e324f096d728c0083d9292f52d" title="This method returns a pointer to the mle object. " alt="" coords="548,917,689,956"/>
<area shape="rect" id="node27" href="../../df/d94/group__core-mle-core.html#gabc154b6e95f5b169febcd7a582dfa1a3" title="This method returns the current Thread interface state. " alt="" coords="523,792,714,831"/>
<area shape="rect" id="node29" href="../../db/dec/group__core-mle-router.html#ga77c040805ea115e685375e15e90ec671" title="This method indicates whether a node is the only router on the network. " alt="" coords="538,855,699,893"/>
<area shape="rect" id="node31" href="../../df/d94/group__core-mle-core.html#gab0d4493caf85385a335ec64e1eb1b70c" title="This method stops the MLE protocol operation. " alt="" coords="540,980,696,1005"/>
<area shape="rect" id="node32" href="../../d6/d44/classThread_1_1KeyManager.html#a048243a0e7564e607510d2ed60c99b2e" title="This method stops KeyManager timers. " alt="" coords="784,795,931,833"/>
<area shape="rect" id="node34" href="../../df/d94/group__core-mle-core.html#gaa5ec48ae440f38d5bf24f9d09ca66c65" title="This method sets the Device State to Detached. " alt="" coords="768,916,948,955"/>
<area shape="rect" id="node36" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html#ad00e58b94ab00cc71a5f3a242b7ef42c" title="This method removes a unicast address from the network interface. " alt="" coords="1015,1059,1186,1097"/>
<area shape="rect" id="node33" href="../../d1/d40/classThread_1_1Timer.html#a9acdec1cdf4edf947c563d40871f2bc8" title="This method stops the timer. " alt="" coords="1279,716,1418,741"/>
<area shape="rect" id="node35" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html#a092484addf28568306ab45941abffff4" title="This method schedules notification of aFlags. " alt="" coords="1265,964,1432,1003"/>
<area shape="rect" id="node40" href="../../d4/dcf/classThread_1_1AddressResolver.html#af9e813b464854994a8beda21d91c989c" title="This method clears the EID&#45;to&#45;RLOC cache. " alt="" coords="1014,944,1187,983"/>
<area shape="rect" id="node41" href="../../dd/d1d/classThread_1_1MeshForwarder.html#a2343ec6e8df3c5885415fa912889a752" title="This method sets the rx&#45;on&#45;when&#45;idle mode. " alt="" coords="1018,652,1183,691"/>
<area shape="rect" id="node44" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html#a9972d917c57200b504d9f2df7eb44974" title="This method returns a reference to the IPv6 network object. " alt="" coords="1038,767,1163,805"/>
<area shape="rect" id="node45" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#ac54ddaad6442e3858eb21a2e7801aeaf" title="This method enables/disables IPv6 forwarding. " alt="" coords="996,829,1205,868"/>
<area shape="rect" id="node37" href="../../d9/d13/classThread_1_1Ip6_1_1NetifUnicastAddress.html#ac7f38e1322075b0e6dfc7afc048f7eec" title="This method returns the next unicast address assigned to the interface. " alt="" coords="1264,1027,1433,1065"/>
<area shape="rect" id="node38" href="../../d9/d13/classThread_1_1Ip6_1_1NetifUnicastAddress.html#a2bb426bd29e271bd1fc09b61d1044911" title="This method returns the unicast address. " alt="" coords="1264,1089,1433,1128"/>
<area shape="rect" id="node39" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a042097e2896ce7eebc1844140c0d2aeb" title="This method indicates whether or not the IPv6 address is a RLOC address. " alt="" coords="1275,1152,1421,1191"/>
<area shape="rect" id="node42" href="../../d6/d88/classThread_1_1Mac_1_1Mac.html#ab74d0b0b142cadd19e6d2a24d441223f" title="This method sets the rx&#45;on&#45;when&#45;idle mode. " alt="" coords="1253,600,1443,639"/>
<area shape="rect" id="node43" href="../../d1/d40/classThread_1_1Timer.html#a475731e21b59be6b17b24f5b5e175f62" title="This method schedules the timer to fire a dt milliseconds from now. " alt="" coords="1278,663,1418,688"/>
</map>
</div>
</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aa42f5d6c360b6b1203d3f808d59c47f3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpBase::OutboundFrameBegin </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This method is called to start a new outbound frame. </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully started a new frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to start a new frame. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="../../dc/d60/classThread_1_1NcpUart.html#a31f1b8b217246e7dcdf0ee2b4e025b83">Thread::NcpUart</a>, and <a class="el" href="../../d0/d2a/classThread_1_1NcpSpi.html#a114f7f0fc7acef21a0c20c6b3910babb">Thread::NcpSpi</a>.</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d9/dc8/classThread_1_1NcpBase_aa42f5d6c360b6b1203d3f808d59c47f3_icgraph.png" border="0" usemap="#d9/dc8/classThread_1_1NcpBase_aa42f5d6c360b6b1203d3f808d59c47f3_icgraph" alt=""/></div>
<map name="d9/dc8/classThread_1_1NcpBase_aa42f5d6c360b6b1203d3f808d59c47f3_icgraph" id="d9/dc8/classThread_1_1NcpBase_aa42f5d6c360b6b1203d3f808d59c47f3_icgraph">
<area shape="rect" id="node2" href="../../d9/dc8/classThread_1_1NcpBase.html#a6a04825243722f9500cac2818a07c7b4" title="This constructor creates and initializes an NcpBase instance. " alt="" coords="247,5,434,31"/>
<area shape="rect" id="node3" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="244,55,436,93"/>
<area shape="rect" id="node4" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="484,55,679,93"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="aa0ddbeb24870f94ca94028e6707e8ffb"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpBase::OutboundFrameEnd </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This method finalizes and sends the current outbound frame. </p>
<p>If no buffer space is available, this method should discard and clear the frame before returning an error status.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully added the message to the frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to add message. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a">Thread::NcpUart</a>, and <a class="el" href="../../d0/d2a/classThread_1_1NcpSpi.html#ae9c67ca2e9b95ac4a4fa5650d44a2eed">Thread::NcpSpi</a>.</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d9/dc8/classThread_1_1NcpBase_aa0ddbeb24870f94ca94028e6707e8ffb_icgraph.png" border="0" usemap="#d9/dc8/classThread_1_1NcpBase_aa0ddbeb24870f94ca94028e6707e8ffb_icgraph" alt=""/></div>
<map name="d9/dc8/classThread_1_1NcpBase_aa0ddbeb24870f94ca94028e6707e8ffb_icgraph" id="d9/dc8/classThread_1_1NcpBase_aa0ddbeb24870f94ca94028e6707e8ffb_icgraph">
<area shape="rect" id="node2" href="../../d9/dc8/classThread_1_1NcpBase.html#a6a04825243722f9500cac2818a07c7b4" title="This constructor creates and initializes an NcpBase instance. " alt="" coords="244,12,431,37"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ad9f0899a44608aaa83751fb657592317"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpBase::OutboundFrameFeedData </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aDataBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aDataBufferLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This method adds data to the current outbound frame being written. </p>
<p>If no buffer space is available, this method should discard and clear the frame before returning an error status.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aDataBuffer</td><td>A pointer to data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aDataBufferLength</td><td>The length of the data buffer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully added new data to the frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to add data. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="../../dc/d60/classThread_1_1NcpUart.html#ab5f242e8e3925bbc1cce59f12b5207c3">Thread::NcpUart</a>, and <a class="el" href="../../d0/d2a/classThread_1_1NcpSpi.html#a636c968d8cce6cbf116c1bf22fb72ecd">Thread::NcpSpi</a>.</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d9/dc8/classThread_1_1NcpBase_ad9f0899a44608aaa83751fb657592317_icgraph.png" border="0" usemap="#d9/dc8/classThread_1_1NcpBase_ad9f0899a44608aaa83751fb657592317_icgraph" alt=""/></div>
<map name="d9/dc8/classThread_1_1NcpBase_ad9f0899a44608aaa83751fb657592317_icgraph" id="d9/dc8/classThread_1_1NcpBase_ad9f0899a44608aaa83751fb657592317_icgraph">
<area shape="rect" id="node2" href="../../d9/dc8/classThread_1_1NcpBase.html#a6a04825243722f9500cac2818a07c7b4" title="This constructor creates and initializes an NcpBase instance. " alt="" coords="247,5,434,31"/>
<area shape="rect" id="node3" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="244,55,436,93"/>
<area shape="rect" id="node4" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="484,55,679,93"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ad1df691c323b4b58912f402465450375"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::NcpBase::OutboundFrameFeedMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This method adds a message to the current outbound frame being written. </p>
<p>If no buffer space is available, this method should discard and clear the frame before returning an error status. In case of success, the passed-in message  should be owned by outbound buffer and should be freed when either the the frame is successfully sent and removed or if the frame is discarded.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessage</td><td>A reference to the message to be added to current frame.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully added the message to the frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to add message. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="../../dc/d60/classThread_1_1NcpUart.html#a7e2aed732161d738b481849ff1dad610">Thread::NcpUart</a>, and <a class="el" href="../../d0/d2a/classThread_1_1NcpSpi.html#a9614ae49bf12256c3b0086c55a877142">Thread::NcpSpi</a>.</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d9/dc8/classThread_1_1NcpBase_ad1df691c323b4b58912f402465450375_icgraph.png" border="0" usemap="#d9/dc8/classThread_1_1NcpBase_ad1df691c323b4b58912f402465450375_icgraph" alt=""/></div>
<map name="d9/dc8/classThread_1_1NcpBase_ad1df691c323b4b58912f402465450375_icgraph" id="d9/dc8/classThread_1_1NcpBase_ad1df691c323b4b58912f402465450375_icgraph">
<area shape="rect" id="node2" href="../../d9/dc8/classThread_1_1NcpBase.html#a6a04825243722f9500cac2818a07c7b4" title="This constructor creates and initializes an NcpBase instance. " alt="" coords="247,5,434,31"/>
<area shape="rect" id="node3" href="../../d9/dc8/classThread_1_1NcpBase.html#ad14f0f1d60c77f7f537a0a441a9fb35c" title="This method is called by the framer whenever a framing error is detected. " alt="" coords="244,55,436,93"/>
<area shape="rect" id="node4" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="484,55,679,93"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/ncp/<a class="el" href="../../df/d54/ncp__base_8hpp_source.html">ncp_base.hpp</a></li>
<li>src/ncp/<a class="el" href="../../d5/d6a/ncp__base_8cpp.html">ncp_base.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><a class="el" href="../../d9/dc8/classThread_1_1NcpBase.html">NcpBase</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
